/// AUTO GENERATED BY build.rs

use std::collections::HashMap;

use webrender_build::shader::ShaderVersion;

pub struct SourceWithDigest {
    pub source: &'static str,
    pub digest: &'static str,
}

pub struct OptimizedSourceWithDigest {
    pub vert_source: &'static str,
    pub frag_source: &'static str,
    pub digest: &'static str,
}

lazy_static! {
  pub static ref UNOPTIMIZED_SHADERS: HashMap<&'static str, SourceWithDigest> = {
    let mut shaders = HashMap::new();
    shaders.insert("base", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/base.glsl"), digest: "d5ae695bab268b7d"});
    shaders.insert("blend", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/blend.glsl"), digest: "c24d37103d7732b9"});
    shaders.insert("brush", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/brush.glsl"), digest: "fc30fd1ae0df270f"});
    shaders.insert("brush_blend", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/brush_blend.glsl"), digest: "a0b12227d014cdaf"});
    shaders.insert("brush_image", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/brush_image.glsl"), digest: "310159b460299e56"});
    shaders.insert("brush_linear_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/brush_linear_gradient.glsl"), digest: "dfaca62a6fa8bcd0"});
    shaders.insert("brush_mix_blend", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/brush_mix_blend.glsl"), digest: "e6954d79b7b8ee72"});
    shaders.insert("brush_opacity", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/brush_opacity.glsl"), digest: "c753bec3ce6e043d"});
    shaders.insert("brush_solid", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/brush_solid.glsl"), digest: "ce8c9c1fc4ffab24"});
    shaders.insert("brush_yuv_image", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/brush_yuv_image.glsl"), digest: "4cab2064bf1e263c"});
    shaders.insert("clip_shared", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/clip_shared.glsl"), digest: "6ff98586e3e3cd56"});
    shaders.insert("composite", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/composite.glsl"), digest: "ba73ac64043a396b"});
    shaders.insert("cs_blur", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/cs_blur.glsl"), digest: "efd07a0e9356b5b9"});
    shaders.insert("cs_border_segment", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/cs_border_segment.glsl"), digest: "90d63490e9b36e56"});
    shaders.insert("cs_border_solid", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/cs_border_solid.glsl"), digest: "5f1578611ca19c6d"});
    shaders.insert("cs_clip_box_shadow", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/cs_clip_box_shadow.glsl"), digest: "8ddba747000d0253"});
    shaders.insert("cs_clip_image", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/cs_clip_image.glsl"), digest: "990749f2a95c1a70"});
    shaders.insert("cs_clip_rectangle", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/cs_clip_rectangle.glsl"), digest: "2ee20685500c6b38"});
    shaders.insert("cs_conic_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/cs_conic_gradient.glsl"), digest: "44022cf28b564b61"});
    shaders.insert("cs_fast_linear_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/cs_fast_linear_gradient.glsl"), digest: "30b59f97c25a9e24"});
    shaders.insert("cs_line_decoration", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/cs_line_decoration.glsl"), digest: "7cc8d3ee2d4fa658"});
    shaders.insert("cs_linear_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/cs_linear_gradient.glsl"), digest: "64c2fbb3a9e409cf"});
    shaders.insert("cs_radial_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/cs_radial_gradient.glsl"), digest: "7cdceb79774469da"});
    shaders.insert("cs_scale", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/cs_scale.glsl"), digest: "c128f6c7ab566e08"});
    shaders.insert("cs_svg_filter", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/cs_svg_filter.glsl"), digest: "5a07de78d866fc7a"});
    shaders.insert("debug_color", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/debug_color.glsl"), digest: "923eead812d0b368"});
    shaders.insert("debug_font", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/debug_font.glsl"), digest: "be05894e9fe62951"});
    shaders.insert("ellipse", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/ellipse.glsl"), digest: "951dc637533b8416"});
    shaders.insert("gpu_buffer", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/gpu_buffer.glsl"), digest: "f7046c285ef0b3d1"});
    shaders.insert("gpu_cache", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/gpu_cache.glsl"), digest: "e99b57d9cc26406a"});
    shaders.insert("gpu_cache_update", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/gpu_cache_update.glsl"), digest: "4ad2e4e46e03b7c2"});
    shaders.insert("gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/gradient.glsl"), digest: "993c4122e49f3fef"});
    shaders.insert("gradient_shared", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/gradient_shared.glsl"), digest: "c7765e50322898d6"});
    shaders.insert("prim_shared", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/prim_shared.glsl"), digest: "5f6b32963b4e80eb"});
    shaders.insert("ps_clear", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/ps_clear.glsl"), digest: "16a101040aa2dee"});
    shaders.insert("ps_copy", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/ps_copy.glsl"), digest: "f0e76514309bd9fa"});
    shaders.insert("ps_quad", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/ps_quad.glsl"), digest: "4a93483e9cd4ebc5"});
    shaders.insert("ps_quad_mask", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/ps_quad_mask.glsl"), digest: "b8a276b31e4f66b"});
    shaders.insert("ps_quad_textured", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/ps_quad_textured.glsl"), digest: "1d5f098f13a43eb9"});
    shaders.insert("ps_split_composite", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/ps_split_composite.glsl"), digest: "5f8757d71f761d45"});
    shaders.insert("ps_text_run", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/ps_text_run.glsl"), digest: "e8bb0e4174b45eeb"});
    shaders.insert("rect", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/rect.glsl"), digest: "a072b75695c59cf6"});
    shaders.insert("render_task", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/render_task.glsl"), digest: "c4574b7a23485833"});
    shaders.insert("shared", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/shared.glsl"), digest: "58dafba376675e09"});
    shaders.insert("shared_other", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/shared_other.glsl"), digest: "9f6298a27dfe79c6"});
    shaders.insert("transform", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/transform.glsl"), digest: "35a01bc6ab4b6f5a"});
    shaders.insert("yuv", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-121.0/gfx/wr/webrender/res/yuv.glsl"), digest: "6c55b98a6ea33a2f"});
    shaders
  };

  pub static ref OPTIMIZED_SHADERS: HashMap<(ShaderVersion, &'static str), OptimizedSourceWithDigest> = {
    let mut shaders = HashMap::new();
    shaders.insert((ShaderVersion::Gl, "brush_blend"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_blend_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_blend_Gl.frag"),
        digest: "8058a66620365a7d",
    });
    shaders.insert((ShaderVersion::Gl, "brush_blend_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_blend_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_blend_ALPHA_PASS_Gl.frag"),
        digest: "afb96409527d0d21",
    });
    shaders.insert((ShaderVersion::Gl, "brush_blend_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_blend_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_blend_DEBUG_OVERDRAW_Gl.frag"),
        digest: "54279562e22cb9e",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "dd822d5fc5b63ae7",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "8a1eb7117f9207a0",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_2D_Gl.frag"),
        digest: "4bf909572041991b",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_RECT_Gl.frag"),
        digest: "3bd8b89b075115f8",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "e43f203ac41b560c",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "f761fbcce3a36035",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "d49127837670525a",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "ad1a52d8e4e77a",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.frag"),
        digest: "34b68544967f77ef",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_RECT_Gl.frag"),
        digest: "36634b4c5e87aec3",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ALPHA_PASS_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ALPHA_PASS_TEXTURE_2D_Gl.frag"),
        digest: "3c4dfe654a0032c6",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ALPHA_PASS_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ALPHA_PASS_TEXTURE_RECT_Gl.frag"),
        digest: "9fe55fa7215fbdf",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "ae7cbbf05b9ad408",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "8b3724c97fec7914",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ANTIALIASING_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "b0ee330dd2ebbf22",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ANTIALIASING_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "3b0821f186c6f7b9",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_DEBUG_OVERDRAW_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_DEBUG_OVERDRAW_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_DEBUG_OVERDRAW_TEXTURE_2D_Gl.frag"),
        digest: "d61107e5696e96d3",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_DEBUG_OVERDRAW_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_DEBUG_OVERDRAW_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_DEBUG_OVERDRAW_TEXTURE_RECT_Gl.frag"),
        digest: "75a261f88b8e4e55",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_TEXTURE_2D_Gl.frag"),
        digest: "2e5428a23906736f",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_image_TEXTURE_RECT_Gl.frag"),
        digest: "46ec8f727cf44a7c",
    });
    shaders.insert((ShaderVersion::Gl, "brush_linear_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_linear_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_linear_gradient_Gl.frag"),
        digest: "cc3c5d5c2837cd49",
    });
    shaders.insert((ShaderVersion::Gl, "brush_linear_gradient_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_linear_gradient_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_linear_gradient_ALPHA_PASS_Gl.frag"),
        digest: "6c417f344466a4c7",
    });
    shaders.insert((ShaderVersion::Gl, "brush_linear_gradient_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_linear_gradient_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_linear_gradient_DEBUG_OVERDRAW_Gl.frag"),
        digest: "f4ab5ba9c81afee0",
    });
    shaders.insert((ShaderVersion::Gl, "brush_mix_blend"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_mix_blend_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_mix_blend_Gl.frag"),
        digest: "fb5fd955bc7c5461",
    });
    shaders.insert((ShaderVersion::Gl, "brush_mix_blend_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_mix_blend_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_mix_blend_ALPHA_PASS_Gl.frag"),
        digest: "33f4fedaf2f70eb8",
    });
    shaders.insert((ShaderVersion::Gl, "brush_mix_blend_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_mix_blend_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_mix_blend_DEBUG_OVERDRAW_Gl.frag"),
        digest: "b216aa79f7c6c0e6",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_opacity_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_opacity_Gl.frag"),
        digest: "48473ad901edd695",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_opacity_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_opacity_ALPHA_PASS_Gl.frag"),
        digest: "ade7a531aa0fb34a",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_ALPHA_PASS_ANTIALIASING"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_opacity_ALPHA_PASS_ANTIALIASING_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_opacity_ALPHA_PASS_ANTIALIASING_Gl.frag"),
        digest: "d811883989d3bb6c",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_ANTIALIASING"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_opacity_ANTIALIASING_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_opacity_ANTIALIASING_Gl.frag"),
        digest: "74908305a20abd78",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_ANTIALIASING_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_opacity_ANTIALIASING_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_opacity_ANTIALIASING_DEBUG_OVERDRAW_Gl.frag"),
        digest: "7895d6dfb6d67967",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_opacity_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_opacity_DEBUG_OVERDRAW_Gl.frag"),
        digest: "2d82259b9569ed98",
    });
    shaders.insert((ShaderVersion::Gl, "brush_solid"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_solid_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_solid_Gl.frag"),
        digest: "c8bb2fae2850c2d7",
    });
    shaders.insert((ShaderVersion::Gl, "brush_solid_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_solid_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_solid_ALPHA_PASS_Gl.frag"),
        digest: "ba5e8cd20a02c43d",
    });
    shaders.insert((ShaderVersion::Gl, "brush_solid_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_solid_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_solid_DEBUG_OVERDRAW_Gl.frag"),
        digest: "2a3f232b8a513101",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_ALPHA_PASS_TEXTURE_2D_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_yuv_image_ALPHA_PASS_TEXTURE_2D_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_yuv_image_ALPHA_PASS_TEXTURE_2D_YUV_Gl.frag"),
        digest: "9e1b445f09de1f62",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_ALPHA_PASS_TEXTURE_RECT_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_yuv_image_ALPHA_PASS_TEXTURE_RECT_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_yuv_image_ALPHA_PASS_TEXTURE_RECT_YUV_Gl.frag"),
        digest: "f25211984e132749",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_2D_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_2D_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_2D_YUV_Gl.frag"),
        digest: "f86a55819b9eb5a4",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_RECT_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_RECT_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_RECT_YUV_Gl.frag"),
        digest: "64f2cf1eae606759",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_TEXTURE_2D_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_yuv_image_TEXTURE_2D_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_yuv_image_TEXTURE_2D_YUV_Gl.frag"),
        digest: "479f551dc7a6b275",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_TEXTURE_RECT_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_yuv_image_TEXTURE_RECT_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/brush_yuv_image_TEXTURE_RECT_YUV_Gl.frag"),
        digest: "39a196d0c22bf291",
    });
    shaders.insert((ShaderVersion::Gl, "composite_FAST_PATH_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/composite_FAST_PATH_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/composite_FAST_PATH_TEXTURE_2D_Gl.frag"),
        digest: "b4abdac35adeca92",
    });
    shaders.insert((ShaderVersion::Gl, "composite_FAST_PATH_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/composite_FAST_PATH_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/composite_FAST_PATH_TEXTURE_RECT_Gl.frag"),
        digest: "4ed90b4b39c4d003",
    });
    shaders.insert((ShaderVersion::Gl, "composite_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/composite_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/composite_TEXTURE_2D_Gl.frag"),
        digest: "49e6f09ccfcebfab",
    });
    shaders.insert((ShaderVersion::Gl, "composite_TEXTURE_2D_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/composite_TEXTURE_2D_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/composite_TEXTURE_2D_YUV_Gl.frag"),
        digest: "ff94e6c0fe6293bd",
    });
    shaders.insert((ShaderVersion::Gl, "composite_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/composite_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/composite_TEXTURE_RECT_Gl.frag"),
        digest: "759b8621deb43f74",
    });
    shaders.insert((ShaderVersion::Gl, "composite_TEXTURE_RECT_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/composite_TEXTURE_RECT_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/composite_TEXTURE_RECT_YUV_Gl.frag"),
        digest: "f10fba04f7c59437",
    });
    shaders.insert((ShaderVersion::Gl, "cs_blur_ALPHA_TARGET"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_blur_ALPHA_TARGET_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_blur_ALPHA_TARGET_Gl.frag"),
        digest: "e1ee6b18274ebea4",
    });
    shaders.insert((ShaderVersion::Gl, "cs_blur_COLOR_TARGET"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_blur_COLOR_TARGET_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_blur_COLOR_TARGET_Gl.frag"),
        digest: "44b296e917f5ffe0",
    });
    shaders.insert((ShaderVersion::Gl, "cs_border_segment"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_border_segment_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_border_segment_Gl.frag"),
        digest: "8495134f5ed37bf5",
    });
    shaders.insert((ShaderVersion::Gl, "cs_border_solid"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_border_solid_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_border_solid_Gl.frag"),
        digest: "9fd688a8c266d2da",
    });
    shaders.insert((ShaderVersion::Gl, "cs_clip_box_shadow_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_clip_box_shadow_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_clip_box_shadow_TEXTURE_2D_Gl.frag"),
        digest: "9f76c2a874c97310",
    });
    shaders.insert((ShaderVersion::Gl, "cs_clip_image_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_clip_image_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_clip_image_TEXTURE_2D_Gl.frag"),
        digest: "b69a0fd2c6027778",
    });
    shaders.insert((ShaderVersion::Gl, "cs_clip_rectangle"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_clip_rectangle_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_clip_rectangle_Gl.frag"),
        digest: "cabc2ef7edf7bd12",
    });
    shaders.insert((ShaderVersion::Gl, "cs_clip_rectangle_FAST_PATH"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_clip_rectangle_FAST_PATH_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_clip_rectangle_FAST_PATH_Gl.frag"),
        digest: "2504a7e464e09644",
    });
    shaders.insert((ShaderVersion::Gl, "cs_conic_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_conic_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_conic_gradient_Gl.frag"),
        digest: "653ad09c4b159697",
    });
    shaders.insert((ShaderVersion::Gl, "cs_fast_linear_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_fast_linear_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_fast_linear_gradient_Gl.frag"),
        digest: "3d4ec20a2b40f905",
    });
    shaders.insert((ShaderVersion::Gl, "cs_line_decoration"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_line_decoration_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_line_decoration_Gl.frag"),
        digest: "7943c68da0973c69",
    });
    shaders.insert((ShaderVersion::Gl, "cs_linear_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_linear_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_linear_gradient_Gl.frag"),
        digest: "ec6e7a133cbb1999",
    });
    shaders.insert((ShaderVersion::Gl, "cs_radial_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_radial_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_radial_gradient_Gl.frag"),
        digest: "ac62439ba9ff459c",
    });
    shaders.insert((ShaderVersion::Gl, "cs_scale_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_scale_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_scale_TEXTURE_2D_Gl.frag"),
        digest: "d30639d4f078578d",
    });
    shaders.insert((ShaderVersion::Gl, "cs_scale_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_scale_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_scale_TEXTURE_RECT_Gl.frag"),
        digest: "29422e04bd4ba508",
    });
    shaders.insert((ShaderVersion::Gl, "cs_svg_filter"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_svg_filter_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/cs_svg_filter_Gl.frag"),
        digest: "aca9420acaec4776",
    });
    shaders.insert((ShaderVersion::Gl, "debug_color"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/debug_color_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/debug_color_Gl.frag"),
        digest: "f458fe7ea40bd77e",
    });
    shaders.insert((ShaderVersion::Gl, "debug_font"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/debug_font_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/debug_font_Gl.frag"),
        digest: "503ec56c19b6bd2c",
    });
    shaders.insert((ShaderVersion::Gl, "ps_clear"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/ps_clear_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/ps_clear_Gl.frag"),
        digest: "9ef2acc3bbd621e8",
    });
    shaders.insert((ShaderVersion::Gl, "ps_copy"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/ps_copy_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/ps_copy_Gl.frag"),
        digest: "514726576460ee72",
    });
    shaders.insert((ShaderVersion::Gl, "ps_quad_mask"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/ps_quad_mask_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/ps_quad_mask_Gl.frag"),
        digest: "7e90f27cdf9b3bf8",
    });
    shaders.insert((ShaderVersion::Gl, "ps_quad_mask_FAST_PATH"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/ps_quad_mask_FAST_PATH_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/ps_quad_mask_FAST_PATH_Gl.frag"),
        digest: "ede808a5df66273b",
    });
    shaders.insert((ShaderVersion::Gl, "ps_quad_textured"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/ps_quad_textured_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/ps_quad_textured_Gl.frag"),
        digest: "63aa92bf7a7ffdfa",
    });
    shaders.insert((ShaderVersion::Gl, "ps_split_composite"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/ps_split_composite_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/ps_split_composite_Gl.frag"),
        digest: "9c48e025688a9b51",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_GLYPH_TRANSFORM_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_GLYPH_TRANSFORM_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_GLYPH_TRANSFORM_TEXTURE_2D_Gl.frag"),
        digest: "b519314a67a939d6",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.frag"),
        digest: "7eab94ec1dfcf3e2",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_ALPHA_PASS_GLYPH_TRANSFORM_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/ps_text_run_ALPHA_PASS_GLYPH_TRANSFORM_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/ps_text_run_ALPHA_PASS_GLYPH_TRANSFORM_TEXTURE_2D_Gl.frag"),
        digest: "18c529f9f37abd3b",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_ALPHA_PASS_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/ps_text_run_ALPHA_PASS_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/ps_text_run_ALPHA_PASS_TEXTURE_2D_Gl.frag"),
        digest: "d6452fea374f6bc",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_DEBUG_OVERDRAW_DUAL_SOURCE_BLENDING_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/ps_text_run_DEBUG_OVERDRAW_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/ps_text_run_DEBUG_OVERDRAW_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.frag"),
        digest: "559befc1e1eab03a",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_DEBUG_OVERDRAW_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/ps_text_run_DEBUG_OVERDRAW_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-121.0/objdir/x86_64-unknown-linux-gnu/release/build/webrender-43fec8b4d2b2d3ac/out/ps_text_run_DEBUG_OVERDRAW_TEXTURE_2D_Gl.frag"),
        digest: "d2d319a46fada8e0",
    });
    shaders
  };
}
